<template>
  <div v-if="currentSidebarPage">
    <component :is="currentSidebarPage.component" v-bind="currentSidebarPage.props"></component>
  </div>
  <div v-else>
    <div class="i3-logo">Y3TI</div>

    <ul class="i3-main-menu">
      <li @click="pushPage('editor-category', {}, 'Editor')"><a href="javascript:void(0)">Editor</a></li>
      <li @click="pushPage('starter-kit-category', {}, 'Starter Kit')"><a href="javascript:void(0)">StarterKit</a></li>
      <li @click="pushPage('site-settings', {}, 'Site Settings')"><a href="javascript:void(0)">Site Settings</a></li>
    </ul>
    <button @click="newNode()">New node</button>

  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import EditorCategory from '@/components/Editable/Sidebar/EditorCategory'
import StarterKitCategory from '@/components/Editable/Sidebar/StarterKitCategory'
import StartingPointCategory from '@/components/Editable/Sidebar/StarterKitCategory/StartingPointCategory'
import NewNodeCategory from '@/components/Editable/Sidebar/NewNodeCategory'
import NewNodeFormCategory from '@/components/Editable/Sidebar/NewNodeCategory/NewNodeFormCategory'
import NewNodePresetsCategory from '@/components/Editable/Sidebar/NewNodeCategory/NewNodePresetsCategory'

import SettingsPageForm from '@/components/Editable/Sidebar/EditorCategory/SettingsPageForm'

export default {
  components: {
    EditorCategory,
    StarterKitCategory,
    StartingPointCategory,
    NewNodeCategory,
    NewNodeFormCategory,
    NewNodePresetsCategory,

    SettingsPageForm
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      currentSidebarPage: 'Y3TI/currentSidebarPage',
      contentTypes: 'Y3TI/contentTypes',
      newNodeId: 'Y3TI/newNodeId',
      getEditedNodes: 'Y3TI/getEditedNodes'
    })
  },

  methods: {
    ...mapActions({
      pushSidebarPage: 'Y3TI/pushSidebarPage',
      backSidebarPage: 'Y3TI/backSidebarPage',
      setNewNodeId: 'Y3TI/setNewNodeId',
      getContentTypes: 'Y3TI/getContentTypes'
    }),

    pushPage (component, props, title) {
      return this.pushSidebarPage({ data: { page: { component, props, title }, action: 'push' } })
    },

    preventMistake () {
      let notSavedData = false
      _.each(this.contentTypes, (name, key) => {
        const data = this.getEditedNodes([key, 'nid-new-' + this.newNodeId])
        if (!_.isEmpty(data)) {
          notSavedData = true
        }
      })

      let ok = true
      if (notSavedData) {
        ok = window.confirm('There is unsaved data. Are you sure you want to override it?')
      }
      return ok
    },

    newNode () {
      if (this.preventMistake()) {
        this.setNewNodeId()
        this.pushPage('new-node-category', {}, 'Select content type for new node')
      }
    }
  },

  created () {
    this.getContentTypes({ options: { lazy: true } })
  }
}
</script>

<style lang="scss">
  @import "@/assets/style/_s4squash.scss";
</style>
